diff --git a/libpurple/purplechanneljoindetails.h b/libpurple/purplechanneljoindetails.h
--- a/libpurple/purplechanneljoindetails.h
+++ b/libpurple/purplechanneljoindetails.h
@@ -26,9 +26,13 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CHANNEL_JOIN_DETAILS (purple_channel_join_details_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleChannelJoinDetails, purple_channel_join_details, PURPLE, CHANNEL_JOIN_DETAILS, GObject)
 
 /**
@@ -52,6 +56,7 @@ G_DECLARE_FINAL_TYPE(PurpleChannelJoinDe
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleChannelJoinDetails *purple_channel_join_details_new(gboolean nickname_supported, gboolean password_supported);
 
 /**
@@ -64,6 +69,7 @@ PurpleChannelJoinDetails *purple_channel
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_channel_join_details_get_name(PurpleChannelJoinDetails *details);
 
 /**
@@ -75,6 +81,7 @@ const char *purple_channel_join_details_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_channel_join_details_set_name(PurpleChannelJoinDetails *details, const char *name);
 
 /**
@@ -87,6 +94,7 @@ void purple_channel_join_details_set_nam
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_channel_join_details_get_nickname(PurpleChannelJoinDetails *details);
 
 /**
@@ -98,6 +106,7 @@ const char *purple_channel_join_details_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_channel_join_details_set_nickname(PurpleChannelJoinDetails *details, const char *nickname);
 
 /**
@@ -110,6 +119,7 @@ void purple_channel_join_details_set_nic
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_channel_join_details_get_nickname_supported(PurpleChannelJoinDetails *details);
 
 /**
@@ -122,6 +132,7 @@ gboolean purple_channel_join_details_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_channel_join_details_get_password(PurpleChannelJoinDetails *details);
 
 /**
@@ -133,6 +144,7 @@ const char *purple_channel_join_details_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_channel_join_details_set_password(PurpleChannelJoinDetails *details, const char *password);
 
 /**
@@ -145,6 +157,7 @@ void purple_channel_join_details_set_pas
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_channel_join_details_get_password_supported(PurpleChannelJoinDetails *details);
 
 /**
@@ -163,6 +176,7 @@ gboolean purple_channel_join_details_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_channel_join_details_merge(PurpleChannelJoinDetails *source, PurpleChannelJoinDetails *destination);
 
 G_END_DECLS
diff --git a/libpurple/purplechatuser.h b/libpurple/purplechatuser.h
--- a/libpurple/purplechatuser.h
+++ b/libpurple/purplechatuser.h
@@ -30,6 +30,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 /**
  * PurpleChatUser:
  *
@@ -92,6 +94,7 @@ PurpleChatUser *purple_chat_user_new(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_chat_user_set_chat(PurpleChatUser *chat_user,
                                PurpleChatConversation *chat);
 
@@ -105,6 +108,7 @@ void purple_chat_user_set_chat(PurpleCha
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleChatConversation *purple_chat_user_get_chat(PurpleChatUser *chat_user);
 
 /**
@@ -117,6 +121,7 @@ PurpleChatConversation *purple_chat_user
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_chat_user_get_alias(PurpleChatUser *chat_user);
 
 /**
@@ -149,6 +154,7 @@ void purple_chat_user_set_flags(PurpleCh
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleChatUserFlags purple_chat_user_get_flags(PurpleChatUser *chat_user);
 
 /**
@@ -161,6 +167,7 @@ PurpleChatUserFlags purple_chat_user_get
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_chat_user_is_buddy(PurpleChatUser *chat_user);
 
 /**
diff --git a/libpurple/purpleconnectionerrorinfo.h b/libpurple/purpleconnectionerrorinfo.h
--- a/libpurple/purpleconnectionerrorinfo.h
+++ b/libpurple/purpleconnectionerrorinfo.h
@@ -26,6 +26,8 @@
 #include <glib.h>
 #include <glib-object.h>
 
+#include "purpleversion.h"
+
 G_BEGIN_DECLS
 
 /**
@@ -136,6 +138,7 @@ GType purple_connection_error_info_get_t
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConnectionErrorInfo *purple_connection_error_info_new(PurpleConnectionError type, const gchar *description);
 
 /**
@@ -148,6 +151,7 @@ PurpleConnectionErrorInfo *purple_connec
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConnectionErrorInfo *purple_connection_error_info_copy(PurpleConnectionErrorInfo *info);
 
 /**
@@ -158,6 +162,7 @@ PurpleConnectionErrorInfo *purple_connec
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_connection_error_info_free(PurpleConnectionErrorInfo *info);
 
 G_END_DECLS
diff --git a/libpurple/purplecontact.h b/libpurple/purplecontact.h
--- a/libpurple/purplecontact.h
+++ b/libpurple/purplecontact.h
@@ -29,10 +29,13 @@
 #include <gdk-pixbuf/gdk-pixbuf.h>
 
 #include "purplecontactinfo.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONTACT (purple_contact_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleContact, purple_contact, PURPLE, CONTACT,
                      PurpleContactInfo)
 
@@ -59,6 +62,7 @@ G_DECLARE_FINAL_TYPE(PurpleContact, purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContact *purple_contact_new(PurpleAccount *account, const gchar *id);
 
 /**
@@ -72,6 +76,7 @@ PurpleContact *purple_contact_new(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAccount *purple_contact_get_account(PurpleContact *contact);
 
 G_END_DECLS
diff --git a/libpurple/purplecontactinfo.h b/libpurple/purplecontactinfo.h
--- a/libpurple/purplecontactinfo.h
+++ b/libpurple/purplecontactinfo.h
@@ -29,6 +29,7 @@
 #include "purpleavatar.h"
 #include "purplepresence.h"
 #include "purpletags.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -49,6 +50,7 @@ G_DECLARE_DERIVABLE_TYPE(PurpleContactIn
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum {
 	PURPLE_CONTACT_INFO_PERMISSION_UNSET = 0,
 	PURPLE_CONTACT_INFO_PERMISSION_ALLOW,
@@ -92,6 +94,7 @@ struct _PurpleContactInfoClass {
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_contact_info_new(const gchar *id);
 
 /**
@@ -107,6 +110,7 @@ PurpleContactInfo *purple_contact_info_n
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_contact_info_get_id(PurpleContactInfo *info);
 
 /**
@@ -120,6 +124,7 @@ const gchar *purple_contact_info_get_id(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_id(PurpleContactInfo *info, const char *id);
 
 /**
@@ -132,6 +137,7 @@ void purple_contact_info_set_id(PurpleCo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_contact_info_get_username(PurpleContactInfo *info);
 
 /**
@@ -146,6 +152,7 @@ const gchar *purple_contact_info_get_use
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_username(PurpleContactInfo *info, const gchar *username);
 
 /**
@@ -160,6 +167,7 @@ void purple_contact_info_set_username(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_contact_info_get_display_name(PurpleContactInfo *info);
 
 /**
@@ -174,6 +182,7 @@ const gchar *purple_contact_info_get_dis
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_display_name(PurpleContactInfo *info, const gchar *display_name);
 
 /**
@@ -186,6 +195,7 @@ void purple_contact_info_set_display_nam
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const gchar *purple_contact_info_get_alias(PurpleContactInfo *info);
 
 /**
@@ -199,6 +209,7 @@ const gchar *purple_contact_info_get_ali
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_alias(PurpleContactInfo *info, const gchar *alias);
 
 /**
@@ -212,6 +223,7 @@ void purple_contact_info_set_alias(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_color(PurpleContactInfo *info);
 
 /**
@@ -227,6 +239,7 @@ const char *purple_contact_info_get_colo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_color(PurpleContactInfo *info, const char *color);
 
 /**
@@ -239,6 +252,7 @@ void purple_contact_info_set_color(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_email(PurpleContactInfo *info);
 
 /**
@@ -250,6 +264,7 @@ const char *purple_contact_info_get_emai
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_email(PurpleContactInfo *info, const char *email);
 
 /**
@@ -262,6 +277,7 @@ void purple_contact_info_set_email(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_phone_number(PurpleContactInfo *info);
 
 /**
@@ -273,6 +289,7 @@ const char *purple_contact_info_get_phon
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_phone_number(PurpleContactInfo *info, const char *phone_number);
 
 /**
@@ -285,6 +302,7 @@ void purple_contact_info_set_phone_numbe
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GTimeZone *purple_contact_info_get_time_zone(PurpleContactInfo *info);
 
 /**
@@ -296,6 +314,7 @@ GTimeZone *purple_contact_info_get_time_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_time_zone(PurpleContactInfo *info, GTimeZone *timezone);
 
 /**
@@ -308,6 +327,7 @@ void purple_contact_info_set_time_zone(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_note(PurpleContactInfo *info);
 
 /**
@@ -319,6 +339,7 @@ const char *purple_contact_info_get_note
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_note(PurpleContactInfo *info, const char *note);
 
 /**
@@ -331,6 +352,7 @@ void purple_contact_info_set_note(Purple
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_contact_info_get_avatar(PurpleContactInfo *info);
 
 /**
@@ -345,6 +367,7 @@ PurpleAvatar *purple_contact_info_get_av
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_avatar(PurpleContactInfo *info, PurpleAvatar *avatar);
 
 /**
@@ -358,6 +381,7 @@ void purple_contact_info_set_avatar(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePresence *purple_contact_info_get_presence(PurpleContactInfo *info);
 
 /**
@@ -370,6 +394,7 @@ PurplePresence *purple_contact_info_get_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_contact_info_get_tags(PurpleContactInfo *info);
 
 /**
@@ -381,6 +406,7 @@ PurpleTags *purple_contact_info_get_tags
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_person(PurpleContactInfo *info, PurplePerson *person);
 
 /**
@@ -394,6 +420,7 @@ void purple_contact_info_set_person(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurplePerson *purple_contact_info_get_person(PurpleContactInfo *info);
 
 /**
@@ -406,6 +433,7 @@ PurplePerson *purple_contact_info_get_pe
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfoPermission purple_contact_info_get_permission(PurpleContactInfo *info);
 
 /**
@@ -417,6 +445,7 @@ PurpleContactInfoPermission purple_conta
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_permission(PurpleContactInfo *info, PurpleContactInfoPermission permission);
 
 /**
@@ -429,6 +458,7 @@ void purple_contact_info_set_permission(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_sid(PurpleContactInfo *info);
 
 /**
@@ -440,6 +470,7 @@ const char *purple_contact_info_get_sid(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_info_set_sid(PurpleContactInfo *info, const char *sid);
 
 /**
@@ -453,6 +484,7 @@ void purple_contact_info_set_sid(PurpleC
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_contact_info_get_name_for_display(PurpleContactInfo *info);
 
 /**
@@ -467,6 +499,7 @@ const char *purple_contact_info_get_name
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 int purple_contact_info_compare(PurpleContactInfo *a, PurpleContactInfo *b);
 
 /**
@@ -485,6 +518,7 @@ int purple_contact_info_compare(PurpleCo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_contact_info_matches(PurpleContactInfo *info, const char *needle);
 
 G_END_DECLS
diff --git a/libpurple/purplecontactmanager.h b/libpurple/purplecontactmanager.h
--- a/libpurple/purplecontactmanager.h
+++ b/libpurple/purplecontactmanager.h
@@ -28,10 +28,13 @@
 
 #include "purpleaccount.h"
 #include "purplecontact.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONTACT_MANAGER (purple_contact_manager_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleContactManager, purple_contact_manager, PURPLE,
                      CONTACT_MANAGER, GObject)
 
@@ -55,6 +58,7 @@ G_DECLARE_FINAL_TYPE(PurpleContactManage
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactManager *purple_contact_manager_get_default(void);
 
 /**
@@ -67,6 +71,7 @@ PurpleContactManager *purple_contact_man
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_manager_add(PurpleContactManager *manager, PurpleContact *contact);
 
 /**
@@ -81,6 +86,7 @@ void purple_contact_manager_add(PurpleCo
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_contact_manager_remove(PurpleContactManager *manager, PurpleContact *contact);
 
 /**
@@ -94,6 +100,7 @@ gboolean purple_contact_manager_remove(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_contact_manager_remove_all(PurpleContactManager *manager, PurpleAccount *account);
 
 /**
@@ -108,6 +115,7 @@ gboolean purple_contact_manager_remove_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_contact_manager_get_all(PurpleContactManager *manager, PurpleAccount *account);
 
 /**
@@ -124,6 +132,7 @@ GListModel *purple_contact_manager_get_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContact *purple_contact_manager_find_with_username(PurpleContactManager *manager, PurpleAccount *account, const gchar *username);
 
 /**
@@ -139,6 +148,7 @@ PurpleContact *purple_contact_manager_fi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContact *purple_contact_manager_find_with_id(PurpleContactManager *manager, PurpleAccount *account, const gchar *id);
 
 /**
@@ -155,7 +165,7 @@ PurpleContact *purple_contact_manager_fi
  *
  * Since: 3.0.0
  */
-G_DEPRECATED
+PURPLE_DEPRECATED
 void purple_contact_manager_add_buddy(PurpleContactManager *manager, PurpleBuddy *buddy);
 
 /**
@@ -172,6 +182,7 @@ void purple_contact_manager_add_buddy(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_manager_add_person(PurpleContactManager *manager, PurplePerson *person);
 
 /**
@@ -186,6 +197,7 @@ void purple_contact_manager_add_person(P
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_contact_manager_remove_person(PurpleContactManager *manager, PurplePerson *person, gboolean remove_contacts);
 
 G_END_DECLS
diff --git a/libpurple/purpleconversation.h b/libpurple/purpleconversation.h
--- a/libpurple/purpleconversation.h
+++ b/libpurple/purpleconversation.h
@@ -34,6 +34,7 @@ G_DECLARE_DERIVABLE_TYPE(PurpleConversat
 #include "purplecontactinfo.h"
 #include "purpleconversationmember.h"
 #include "purplemessage.h"
+#include "purpleversion.h"
 
 /**
  * PurpleConversationUpdateType:
@@ -105,6 +106,7 @@ typedef enum
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef enum {
 	PurpleConversationTypeUnset,
 	PurpleConversationTypeDM,
@@ -188,6 +190,7 @@ PurpleConversationUiOps *purple_conversa
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_conversation_get_id(PurpleConversation *conversation);
 
 /**
@@ -200,6 +203,7 @@ const char *purple_conversation_get_id(P
  *
  * Since: 3.0.0.
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationType purple_conversation_get_conversation_type(PurpleConversation *conversation);
 
 /**
@@ -214,6 +218,7 @@ PurpleConversationType purple_conversati
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_conversation_type(PurpleConversation *conversation, PurpleConversationType type);
 
 /**
@@ -420,6 +425,7 @@ gboolean purple_conversation_present_err
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_get_age_restricted(PurpleConversation *conversation);
 
 /**
@@ -432,6 +438,7 @@ gboolean purple_conversation_get_age_res
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_age_restricted(PurpleConversation *conversation, gboolean age_restricted);
 
 /**
@@ -444,6 +451,7 @@ void purple_conversation_set_age_restric
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_conversation_get_description(PurpleConversation *conversation);
 
 /**
@@ -455,6 +463,7 @@ const char *purple_conversation_get_desc
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_description(PurpleConversation *conversation, const char *description);
 
 /**
@@ -467,6 +476,7 @@ void purple_conversation_set_description
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_conversation_get_topic(PurpleConversation *conversation);
 
 /**
@@ -478,6 +488,7 @@ const char *purple_conversation_get_topi
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_topic(PurpleConversation *conversation, const char *topic);
 
 /**
@@ -495,6 +506,7 @@ void purple_conversation_set_topic(Purpl
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_topic_full(PurpleConversation *conversation, const char *topic, PurpleContactInfo *author, GDateTime *updated);
 
 /**
@@ -507,6 +519,7 @@ void purple_conversation_set_topic_full(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_conversation_get_topic_author(PurpleConversation *conversation);
 
 /**
@@ -518,6 +531,7 @@ PurpleContactInfo *purple_conversation_g
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_topic_author(PurpleConversation *conversation, PurpleContactInfo *author);
 
 /**
@@ -531,6 +545,7 @@ void purple_conversation_set_topic_autho
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_conversation_get_topic_updated(PurpleConversation *conversation);
 
 /**
@@ -542,6 +557,7 @@ GDateTime *purple_conversation_get_topic
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_topic_updated(PurpleConversation *conversation, GDateTime *updated);
 
 /**
@@ -554,6 +570,7 @@ void purple_conversation_set_topic_updat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 const char *purple_conversation_get_user_nickname(PurpleConversation *conversation);
 
 /**
@@ -565,6 +582,7 @@ const char *purple_conversation_get_user
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_user_nickname(PurpleConversation *conversation, const char *nickname);
 
 /**
@@ -578,6 +596,7 @@ void purple_conversation_set_user_nickna
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_get_favorite(PurpleConversation *conversation);
 
 /**
@@ -589,6 +608,7 @@ gboolean purple_conversation_get_favorit
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_favorite(PurpleConversation *conversation, gboolean favorite);
 
 /**
@@ -601,6 +621,7 @@ void purple_conversation_set_favorite(Pu
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GDateTime *purple_conversation_get_created_on(PurpleConversation *conversation);
 
 /**
@@ -612,6 +633,7 @@ GDateTime *purple_conversation_get_creat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_created_on(PurpleConversation *conversation, GDateTime *created_on);
 
 /**
@@ -624,6 +646,7 @@ void purple_conversation_set_created_on(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_conversation_get_creator(PurpleConversation *conversation);
 
 /**
@@ -635,6 +658,7 @@ PurpleContactInfo *purple_conversation_g
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_creator(PurpleConversation *conversation, PurpleContactInfo *creator);
 
 /**
@@ -650,6 +674,7 @@ void purple_conversation_set_creator(Pur
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_get_online(PurpleConversation *conversation);
 
 /**
@@ -662,6 +687,7 @@ gboolean purple_conversation_get_online(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_online(PurpleConversation *conversation, gboolean online);
 
 /**
@@ -679,6 +705,7 @@ void purple_conversation_set_online(Purp
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_get_federated(PurpleConversation *conversation);
 
 /**
@@ -691,6 +718,7 @@ gboolean purple_conversation_get_federat
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_conversation_get_tags(PurpleConversation *conversation);
 
 /**
@@ -703,6 +731,7 @@ PurpleTags *purple_conversation_get_tags
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_conversation_get_members(PurpleConversation *conversation);
 
 /**
@@ -720,6 +749,7 @@ GListModel *purple_conversation_get_memb
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_has_member(PurpleConversation *conversation, PurpleContactInfo *info, guint *position);
 
 /**
@@ -735,6 +765,7 @@ gboolean purple_conversation_has_member(
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationMember *purple_conversation_find_member(PurpleConversation *conversation, PurpleContactInfo *info);
 
 /**
@@ -765,6 +796,7 @@ PurpleConversationMember *purple_convers
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationMember *purple_conversation_add_member(PurpleConversation *conversation, PurpleContactInfo *info, gboolean announce, const char *message);
 
 /**
@@ -787,6 +819,7 @@ PurpleConversationMember *purple_convers
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_remove_member(PurpleConversation *conversation, PurpleConversationMember *member, gboolean announce, const char *message);
 
 /**
@@ -799,6 +832,7 @@ gboolean purple_conversation_remove_memb
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GListModel *purple_conversation_get_messages(PurpleConversation *conversation);
 
 /**
@@ -814,6 +848,7 @@ GListModel *purple_conversation_get_mess
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleAvatar *purple_conversation_get_avatar(PurpleConversation *conversation);
 
 /**
@@ -828,6 +863,7 @@ PurpleAvatar *purple_conversation_get_av
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_set_avatar(PurpleConversation *conversation, PurpleAvatar *avatar);
 
 G_END_DECLS
diff --git a/libpurple/purpleconversationmanager.h b/libpurple/purpleconversationmanager.h
--- a/libpurple/purpleconversationmanager.h
+++ b/libpurple/purpleconversationmanager.h
@@ -26,6 +26,7 @@
 #include <glib.h>
 
 #include "purpleconversation.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
@@ -39,6 +40,7 @@ G_BEGIN_DECLS
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleConversationManager, purple_conversation_manager,
                      PURPLE, CONVERSATION_MANAGER, GObject)
 
@@ -52,6 +54,7 @@ G_DECLARE_FINAL_TYPE(PurpleConversationM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_TYPE_IN_3_0
 typedef void (*PurpleConversationManagerForeachFunc)(PurpleConversation *conversation, gpointer data);
 
 /**
@@ -64,6 +67,7 @@ typedef void (*PurpleConversationManager
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationManager *purple_conversation_manager_get_default(void);
 
 /**
@@ -77,6 +81,7 @@ PurpleConversationManager *purple_conver
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_manager_register(PurpleConversationManager *manager, PurpleConversation *conversation);
 
 /**
@@ -90,6 +95,7 @@ gboolean purple_conversation_manager_reg
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_manager_unregister(PurpleConversationManager *manager, PurpleConversation *conversation);
 
 /**
@@ -104,6 +110,7 @@ gboolean purple_conversation_manager_unr
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 gboolean purple_conversation_manager_is_registered(PurpleConversationManager *manager, PurpleConversation *conversation);
 
 /**
@@ -116,6 +123,7 @@ gboolean purple_conversation_manager_is_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_manager_foreach(PurpleConversationManager *manager, PurpleConversationManagerForeachFunc func, gpointer data);
 
 /**
@@ -129,6 +137,7 @@ void purple_conversation_manager_foreach
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 GList *purple_conversation_manager_get_all(PurpleConversationManager *manager);
 
 /**
@@ -146,6 +155,7 @@ GList *purple_conversation_manager_get_a
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_conversation_manager_find(PurpleConversationManager *manager, PurpleAccount *account, const gchar *name);
 
 /**
@@ -161,6 +171,7 @@ PurpleConversation *purple_conversation_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_conversation_manager_find_im(PurpleConversationManager *manager, PurpleAccount *account, const gchar *name);
 
 /**
@@ -176,6 +187,7 @@ PurpleConversation *purple_conversation_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_conversation_manager_find_chat(PurpleConversationManager *manager, PurpleAccount *account, const gchar *name);
 
 /**
@@ -193,6 +205,7 @@ PurpleConversation *purple_conversation_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_conversation_manager_find_chat_by_id(PurpleConversationManager *manager, PurpleAccount *account, gint id);
 
 /**
@@ -208,6 +221,7 @@ PurpleConversation *purple_conversation_
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversation *purple_conversation_manager_find_with_id(PurpleConversationManager *manager, PurpleAccount *account, const char *id);
 
 G_END_DECLS
diff --git a/libpurple/purpleconversationmember.h b/libpurple/purpleconversationmember.h
--- a/libpurple/purpleconversationmember.h
+++ b/libpurple/purpleconversationmember.h
@@ -29,10 +29,13 @@
 #include "purplecontactinfo.h"
 #include "purpletags.h"
 #include "purpletyping.h"
+#include "purpleversion.h"
 
 G_BEGIN_DECLS
 
 #define PURPLE_TYPE_CONVERSATION_MEMBER (purple_conversation_member_get_type())
+
+PURPLE_AVAILABLE_IN_3_0
 G_DECLARE_FINAL_TYPE(PurpleConversationMember, purple_conversation_member,
                      PURPLE, CONVERSATION_MEMBER, GObject)
 
@@ -63,6 +66,7 @@ G_DECLARE_FINAL_TYPE(PurpleConversationM
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleConversationMember *purple_conversation_member_new(PurpleContactInfo *info);
 
 /**
@@ -76,6 +80,7 @@ PurpleConversationMember *purple_convers
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleContactInfo *purple_conversation_member_get_contact_info(PurpleConversationMember *conversation_member);
 
 /**
@@ -88,6 +93,7 @@ PurpleContactInfo *purple_conversation_m
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTags *purple_conversation_member_get_tags(PurpleConversationMember *conversation_member);
 
 /**
@@ -100,6 +106,7 @@ PurpleTags *purple_conversation_member_g
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 PurpleTypingState purple_conversation_member_get_typing_state(PurpleConversationMember *member);
 
 /**
@@ -115,6 +122,7 @@ PurpleTypingState purple_conversation_me
  *
  * Since: 3.0.0
  */
+PURPLE_AVAILABLE_IN_3_0
 void purple_conversation_member_set_typing_state(PurpleConversationMember *member, PurpleTypingState state, guint seconds);
 
 G_END_DECLS
